require 'rubygems'
require "bundler/setup"
require 'yaml'
require 'json'
require 'rest_client'
require 'ostruct'

require 'innologix/client'
require 'innologix/request_error'
require 'innologix/logger'
require 'innologix/device_type'
require 'innologix/device'
require 'innologix/group'
require 'innologix/m2m'
require 'innologix/storage'
require 'innologix/supervisor'
require 'innologix/user'
require 'innologix/device_log'
require 'innologix/sla_group'

module Innologix
  @config = nil

  class << self
    def config
      @config ||= load_config(config_path)
    end

    def config_path
      if defined?(Rails)
        File.join(Rails.root, 'config', 'innologix.yml')
      else
        ENV['CONFIG_PATH'] != nil ? ENV['CONFIG_PATH'] + '/innologix.yml' : 'innologix.yml'
      end
    end

    def load_config(yaml_file)
      return {} unless File.exist?(yaml_file)
      cfg = YAML::load(File.open(yaml_file))
      if defined? Rails
        cfg = cfg[Rails.env]
      end
      cfg
    end
  end
end
